use godot::prelude::*;

struct GodotYaml;

#[gdextension]
unsafe impl ExtensionLibrary for GodotYaml {
}

#[derive(GodotClass)]
#[class(init, base=RefCounted)]
struct MyStruct;

#[godot_api]
impl IRefCounted for MyStruct {}

#[godot_api]
impl MyStruct {
    #[func]
    fn untyped_error(array: Variant) {
        if array.get_type() == VariantType::ARRAY {
            let converted_typed = array.to::<Array<GString>>();
            godot_print!("Array contents: {}", converted_typed);
        }
    }

    #[func]
    fn typed_error(array: Variant) {
        if array.get_type() == VariantType::ARRAY {
            let converted = array.to::<VariantArray>();
            godot_print!("Array contents: {}", converted);
        }
    }
}
